var Discover = require('../lib/discover.js');

var c = new Discover({ mastersRequired : 2 });

c.on("promotion", function () {
	console.log("I was promoted.");
	
	c.advertise({
		RedisMonitor : {
			protocol : 'tcp',
			port : 5555
		}
	});
});

c.on("demotion", function () {
	console.log("I was demoted.");
	
	c.advertise(null);
});

c.on("added", function (obj) {
	console.log("Node added; here are all the nodes:");
// 	c.eachNode(function (node) {
// 		console.log(node);
// 	});
});

c.on("removed", function (obj) {
	console.log("Node removed; here are all the nodes:");
// 	c.eachNode(function (node) {
// 		console.log(node);
// 	});
});

c.on("master", function (obj) {
	console.log("New master.");
});

var AppConsole = require('appconsole').AppConsole;

var a = new AppConsole();

a.commands.push({
	"start" : function () {
		c.start();
	},
	"stop" : function () {
		c.stop();
	},
	"promote" : function () {
		c.promote();
	},
	"demote" : function () {
		c.demote(true);
	},
	"join" : function (channel) {
		if (!c.join(channel, function (obj) {
			console.log(channel + ": " + obj);
		})) {
			console.log("Could not join that channel.");
		}
	},
	"leave" : function (channel) {
		c.leave(channel);
	},
	"send" : function (channel, obj) {
		var args = Array.prototype.slice.call(arguments);
		
		if (!c.send(channel, args.slice(1).join(" "))) {
			console.log("Could not send on that channel.");
		}
	},
	"channels" : function () {
		console.log(c.channels);
	},
	"nodes" : function () {
		c.eachNode(function (node) {
			console.log(node);
		});
	},
	"" : function () {},
	quit : function () {
		process.exit();
	},
	"help" : a.showCommandHelp
});
